// PipeServer.cpp : Defines the entry point for the console application.

#include "stdafx.h"

int main(void)
{
     HANDLE hPipe = CreateNamedPipe("\\\\.\\Pipe\\TestPipe1",PIPE_ACCESS_DUPLEX,PIPE_TYPE_MESSAGE|PIPE_READMODE_MESSAGE|PIPE_WAIT,PIPE_UNLIMITED_INSTANCES,4096,4096,NMPWAIT_USE_DEFAULT_WAIT,NULL);                    // default security attribute 
     
	 if (hPipe==INVALID_HANDLE_VALUE)
		 exit(1);
     
     printf("Pipe created.\n");
	 
	 while(1)
	 {
		printf("Now waiting for connection ...");
         
		BOOL client = ConnectNamedPipe(hPipe, NULL);
		if (!client)
		{
			printf(" error\n"); 
			exit(1);
		}
		else
		{
			printf(" connection successful.\n");
		}
		    
		char buffer[4096];
		DWORD BytesRead,BytesWritten;

		BOOL ok = ReadFile(hPipe,(void*)buffer,4096,&BytesRead,NULL);
		if (!ok||!BytesRead) 
		{
			printf("\nCannot read from pipe.\n");
			CloseHandle(hPipe);
			exit(1);
		}
		printf("Read from client: '%s'\n", buffer);
		    
		ok = WriteFile(hPipe,"OK",3,&BytesWritten,NULL);
		if (!ok||BytesWritten!=3)
		{
			printf("\nCannot write to pipe.\n");
			CloseHandle(hPipe);
			exit(1);
		}
		printf("Written OK to pipe\n");

		ok=FlushFileBuffers(hPipe);
		if (!ok)
		{
			printf("\nCannot flush pipe.\n");
			CloseHandle(hPipe);
			exit(1);
		}
		printf("Buffers flushed.\n");

		ok=DisconnectNamedPipe(hPipe);
		if (!ok)
		{
			printf("\nCannot disconnect pipe.\n");
			CloseHandle(hPipe);
			exit(1);
		}
		printf("Pipe disconnected.\n");
	 }	    

     CloseHandle(hPipe);
     return 0;
}